#ifndef _SERVER_THREAD_H
#define _SERVER_THREAD_H

#include <queue>
#include <glibmm/thread.h>

#include "helloworld-cpp-stubs.h"

namespace hellomodule
{
  class server_thread
    {
    private:

      Glib::Thread * glib_thread;

      Glib::Mutex thread_mutex_;
      Glib::Cond activity_;
      std::queue<hellomodule::Hello_ptr> queue_;

      server_thread (const server_thread& copy);

    public:

      server_thread ();
      ~server_thread ();

      void thread_consumer (void);

      void queue (hellomodule::Hello_ptr work);
    };
};

#endif
