/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: t;c-basic-offset: 4 -*- */
#ifndef _ORBIT_CPP_IDL_helloworld_IMPL_HH
#define _ORBIT_CPP_IDL_helloworld_IMPL_HH

#include "helloworld-cpp-skels.h"
#include "server_thread.h"


namespace hellomodule
{

//Inherit from abstract Skeleton:
class Hello_impl : public POA_hellomodule::Hello
{
public:

	void ping (void) throw(CORBA::SystemException);

	void create_thread (void)
		throw(CORBA::SystemException);

	void submit_work (Hello_ptr server)
		throw(CORBA::SystemException);

	server_thread* thread;

};

}; // namespace hellomodule


#endif //_ORBIT_CPP_IDL_helloworld_IMPL_HH
